{
    "$graph": [
        {
            "class": "CommandLineTool",
            "arguments": [
                "$(inputs.bwa)",
                "mem",
                "-t",
                "$(inputs.t)",
                "-PM",
                "-R",
                "@RG\tID:$(inputs.ID)\tLB:$(inputs.LB)\tSM:$(inputs.SM)\tPL:$(inputs.PL)\tPU:$(inputs.PU)\tCN:$(inputs.CN)",
                "$(inputs.reference_fasta)",
                "$(inputs.fastq1.path)",
                "$(inputs.fastq2.path)"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 30000,
                    "coresMin": 4,
                    "outdirMax": 20000
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#bwa-mem.cwl/CN"
                },
                {
                    "type": "string",
                    "id": "#bwa-mem.cwl/ID"
                },
                {
                    "type": "int",
                    "id": "#bwa-mem.cwl/LB"
                },
                {
                    "type": "string",
                    "id": "#bwa-mem.cwl/PL"
                },
                {
                    "type": "string",
                    "id": "#bwa-mem.cwl/PU"
                },
                {
                    "type": "string",
                    "id": "#bwa-mem.cwl/SM"
                },
                {
                    "type": "string",
                    "id": "#bwa-mem.cwl/bwa"
                },
                {
                    "type": "File",
                    "id": "#bwa-mem.cwl/fastq1"
                },
                {
                    "type": "File",
                    "id": "#bwa-mem.cwl/fastq2"
                },
                {
                    "type": "string",
                    "id": "#bwa-mem.cwl/reference_fasta"
                },
                {
                    "type": "string",
                    "id": "#bwa-mem.cwl/reference_fasta_fai"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "prefix": "--sam"
                    },
                    "id": "#bwa-mem.cwl/sam"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "4",
                    "id": "#bwa-mem.cwl/t"
                }
            ],
            "stdout": "$(inputs.fastq1.basename.replace('_R1', '').replace('.fastq.gz', '_aln.sam'))",
            "id": "#bwa-mem.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.fastq1.basename.replace('_R1', '').replace('.fastq.gz', '_aln.sam'))"
                    },
                    "id": "#bwa-mem.cwl/output_sam"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "arguments": [
                "$(inputs.java)",
                "-Xmx4g",
                "-jar",
                "$(inputs.arrg)",
                "TMP_DIR=/scratch"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMin": 16000,
                    "coresMin": 2,
                    "outdirMax": 80000,
                    "class": "ResourceRequirement"
                }
            ],
            "doc": "None\n",
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "RGCN=",
                        "separate": false
                    },
                    "id": "#AddOrReplaceReadGroups.cwl/CN"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "RGID=",
                        "separate": false
                    },
                    "id": "#AddOrReplaceReadGroups.cwl/ID"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "RGLB=",
                        "separate": false
                    },
                    "id": "#AddOrReplaceReadGroups.cwl/LB"
                },
                {
                    "type": "string",
                    "doc": "Output file (bam or sam).",
                    "default": "$(inputs.input_sam.basename.replace('.sam', '_srt.bam'))",
                    "inputBinding": {
                        "prefix": "O=",
                        "separate": false,
                        "valueFrom": "$(inputs.input_sam.basename.replace('.sam', '_srt.bam'))"
                    },
                    "id": "#AddOrReplaceReadGroups.cwl/O"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "RGPL=",
                        "separate": false
                    },
                    "id": "#AddOrReplaceReadGroups.cwl/PL"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "RGPU=",
                        "separate": false
                    },
                    "id": "#AddOrReplaceReadGroups.cwl/PU"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "RGSM=",
                        "separate": false
                    },
                    "id": "#AddOrReplaceReadGroups.cwl/SM"
                },
                {
                    "type": "string",
                    "id": "#AddOrReplaceReadGroups.cwl/arrg"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "COMPRESSION_LEVEL=",
                        "separate": false
                    },
                    "id": "#AddOrReplaceReadGroups.cwl/compression_level"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "prefix": "CREATE_INDEX=true"
                    },
                    "id": "#AddOrReplaceReadGroups.cwl/create_index"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "I=",
                        "separate": false
                    },
                    "id": "#AddOrReplaceReadGroups.cwl/input_sam"
                },
                {
                    "type": "string",
                    "id": "#AddOrReplaceReadGroups.cwl/java"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "SO=",
                        "separate": false
                    },
                    "id": "#AddOrReplaceReadGroups.cwl/sort_order"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "TMP_DIR=",
                        "separate": false
                    },
                    "id": "#AddOrReplaceReadGroups.cwl/tmp_dir"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "VALIDATION_STRINGENCY=",
                        "separate": false
                    },
                    "id": "#AddOrReplaceReadGroups.cwl/validation_stringency"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${return '*.bai'}"
                    },
                    "id": "#AddOrReplaceReadGroups.cwl/bai"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.input_sam.basename.replace('.sam', '_srt.bam'))"
                    },
                    "id": "#AddOrReplaceReadGroups.cwl/bam"
                }
            ],
            "id": "#AddOrReplaceReadGroups.cwl"
        },
        {
            "class": "CommandLineTool",
            "arguments": [
                "$(inputs.java)",
                "-Xmx4g",
                "-jar",
                "$(inputs.picard)",
                "MarkDuplicates"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMin": 30000,
                    "coresMin": 2,
                    "outdirMax": 100000,
                    "class": "ResourceRequirement"
                }
            ],
            "doc": "None\n",
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "File to write duplication metrics to Required.",
                    "default": "$( inputs.input_bam.basename.replace('.bam', '.md_metrics') )",
                    "inputBinding": {
                        "prefix": "M=",
                        "valueFrom": "$( inputs.input_bam.basename.replace('.bam', '.md_metrics') )",
                        "separate": false
                    },
                    "id": "#MarkDuplicates.cwl/M"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "The output file to write marked records to",
                    "default": "$( inputs.input_bam.basename.replace('.bam', '_MD.bam') )",
                    "inputBinding": {
                        "prefix": "O=",
                        "valueFrom": "$( inputs.input_bam.basename.replace('.bam', '_MD.bam') )",
                        "separate": false
                    },
                    "id": "#MarkDuplicates.cwl/O"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": true,
                    "inputBinding": {
                        "prefix": "ASSUME_SORTED=true"
                    },
                    "id": "#MarkDuplicates.cwl/assume_sorted"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "COMPRESSION_LEVEL=",
                        "separate": false
                    },
                    "id": "#MarkDuplicates.cwl/compression_level"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": true,
                    "inputBinding": {
                        "prefix": "CREATE_INDEX=true"
                    },
                    "id": "#MarkDuplicates.cwl/create_index"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "DUPLICATE_SCORING_STRATEGY=",
                        "separate": false
                    },
                    "id": "#MarkDuplicates.cwl/duplicate_scoring_strategy"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "I=",
                        "separate": false
                    },
                    "id": "#MarkDuplicates.cwl/input_bam"
                },
                {
                    "type": "string",
                    "id": "#MarkDuplicates.cwl/java"
                },
                {
                    "type": "string",
                    "id": "#MarkDuplicates.cwl/picard"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "TMP_DIR=",
                        "separate": false
                    },
                    "id": "#MarkDuplicates.cwl/tmp_dir"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "VALIDATION_STRINGENCY=",
                        "separate": false
                    },
                    "id": "#MarkDuplicates.cwl/validation_stringency"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_bam.basename.replace('.bam', '_MD.bai'))"
                    },
                    "id": "#MarkDuplicates.cwl/bai"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.input_bam.basename.replace('.bam', '_MD.bam'))"
                    },
                    "id": "#MarkDuplicates.cwl/bam"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_bam.basename.replace('.bam', '.md_metrics'))"
                    },
                    "id": "#MarkDuplicates.cwl/mdmetrics"
                }
            ],
            "id": "#MarkDuplicates.cwl"
        },
        {
            "class": "CommandLineTool",
            "arguments": [
                "$(inputs.perl)",
                "$(inputs.trimgalore)"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 16000,
                    "coresMin": 2,
                    "outdirMax": 20000
                }
            ],
            "doc": "None\n",
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-a"
                    },
                    "id": "#trimgalore.cwl/adapter"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-a2"
                    },
                    "id": "#trimgalore.cwl/adapter2"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 999
                    },
                    "id": "#trimgalore.cwl/fastq1"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1000
                    },
                    "id": "#trimgalore.cwl/fastq2"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "prefix": "--gzip"
                    },
                    "id": "#trimgalore.cwl/gzip"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "-length"
                    },
                    "id": "#trimgalore.cwl/length"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "prefix": "--paired"
                    },
                    "id": "#trimgalore.cwl/paired"
                },
                {
                    "type": "string",
                    "id": "#trimgalore.cwl/perl"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "-q"
                    },
                    "id": "#trimgalore.cwl/quality"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "--stringency"
                    },
                    "id": "#trimgalore.cwl/stringency"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "prefix": "--suppress_warn"
                    },
                    "id": "#trimgalore.cwl/suppress_warn"
                },
                {
                    "type": "string",
                    "id": "#trimgalore.cwl/trimgalore"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.fastq1.basename.replace('.fastq.gz', '_cl.fastq.gz'))"
                    },
                    "id": "#trimgalore.cwl/clfastq1"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.fastq2.basename.replace('.fastq.gz', '_cl.fastq.gz'))"
                    },
                    "id": "#trimgalore.cwl/clfastq2"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.fastq1.basename.replace('.fastq.gz', '_cl.stats'))"
                    },
                    "id": "#trimgalore.cwl/clstats1"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.fastq2.basename.replace('.fastq.gz', '_cl.stats'))"
                    },
                    "id": "#trimgalore.cwl/clstats2"
                }
            ],
            "id": "#trimgalore.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "types": [
                        {
                            "type": "record",
                            "name": "#collapsing_tools.yaml/run_tools",
                            "fields": [
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/perl_5",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/java_7",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/java_8",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/marianas_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/bioinfo_utils",
                                    "type": "File"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/trimgalore_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/bwa_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/arrg_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/picard_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/gatk_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/abra_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/fx_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/waltz_path",
                                    "type": "string"
                                }
                            ]
                        },
                        {
                            "name": "#trimgalore.yaml/trimgalore__params",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#trimgalore.yaml/trimgalore__params/length",
                                    "type": "int"
                                },
                                {
                                    "name": "#trimgalore.yaml/trimgalore__params/paired",
                                    "type": "boolean"
                                },
                                {
                                    "name": "#trimgalore.yaml/trimgalore__params/gzip",
                                    "type": "boolean"
                                },
                                {
                                    "name": "#trimgalore.yaml/trimgalore__params/quality",
                                    "type": "int"
                                },
                                {
                                    "name": "#trimgalore.yaml/trimgalore__params/stringency",
                                    "type": "int"
                                },
                                {
                                    "name": "#trimgalore.yaml/trimgalore__params/suppress_warn",
                                    "type": "boolean"
                                }
                            ]
                        },
                        {
                            "name": "#add_or_replace_read_groups.yaml/add_or_replace_read_groups__params",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#add_or_replace_read_groups.yaml/add_or_replace_read_groups__params/add_rg_PL",
                                    "type": "string"
                                },
                                {
                                    "name": "#add_or_replace_read_groups.yaml/add_or_replace_read_groups__params/add_rg_CN",
                                    "type": "string"
                                },
                                {
                                    "name": "#add_or_replace_read_groups.yaml/add_or_replace_read_groups__params/sort_order",
                                    "type": "string"
                                },
                                {
                                    "name": "#add_or_replace_read_groups.yaml/add_or_replace_read_groups__params/validation_stringency",
                                    "type": "string"
                                },
                                {
                                    "name": "#add_or_replace_read_groups.yaml/add_or_replace_read_groups__params/compression_level",
                                    "type": "int"
                                },
                                {
                                    "name": "#add_or_replace_read_groups.yaml/add_or_replace_read_groups__params/create_index",
                                    "type": "boolean"
                                }
                            ]
                        },
                        {
                            "name": "#mark_duplicates.yaml/mark_duplicates__params",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#mark_duplicates.yaml/mark_duplicates__params/create_index",
                                    "type": "boolean"
                                },
                                {
                                    "name": "#mark_duplicates.yaml/mark_duplicates__params/assume_sorted",
                                    "type": "boolean"
                                },
                                {
                                    "name": "#mark_duplicates.yaml/mark_duplicates__params/compression_level",
                                    "type": "int"
                                },
                                {
                                    "name": "#mark_duplicates.yaml/mark_duplicates__params/validation_stringency",
                                    "type": "string"
                                },
                                {
                                    "name": "#mark_duplicates.yaml/mark_duplicates__params/duplicate_scoring_strategy",
                                    "type": "string"
                                }
                            ]
                        }
                    ],
                    "class": "SchemaDefRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#main/adapter"
                },
                {
                    "type": "string",
                    "id": "#main/adapter2"
                },
                {
                    "type": "#add_or_replace_read_groups.yaml/add_or_replace_read_groups__params",
                    "id": "#main/add_or_replace_read_groups__params"
                },
                {
                    "type": "string",
                    "id": "#main/add_rg_CN"
                },
                {
                    "type": "string",
                    "id": "#main/add_rg_ID"
                },
                {
                    "type": "int",
                    "id": "#main/add_rg_LB"
                },
                {
                    "type": "string",
                    "id": "#main/add_rg_PL"
                },
                {
                    "type": "string",
                    "id": "#main/add_rg_PU"
                },
                {
                    "type": "string",
                    "id": "#main/add_rg_SM"
                },
                {
                    "type": "File",
                    "id": "#main/fastq1"
                },
                {
                    "type": "File",
                    "id": "#main/fastq2"
                },
                {
                    "type": "#mark_duplicates.yaml/mark_duplicates__params",
                    "id": "#main/mark_duplicates__params"
                },
                {
                    "type": "string",
                    "id": "#main/reference_fasta"
                },
                {
                    "type": "string",
                    "id": "#main/reference_fasta_fai"
                },
                {
                    "type": "#collapsing_tools.yaml/run_tools",
                    "id": "#main/run_tools"
                },
                {
                    "type": "#trimgalore.yaml/trimgalore__params",
                    "id": "#main/trimgalore__params"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/picard.MarkDuplicates/bai",
                    "id": "#main/bai"
                },
                {
                    "type": "File",
                    "outputSource": "#main/picard.MarkDuplicates/bam",
                    "id": "#main/bam"
                },
                {
                    "type": "File",
                    "outputSource": "#main/trimgalore/clstats1",
                    "id": "#main/clstats1"
                },
                {
                    "type": "File",
                    "outputSource": "#main/trimgalore/clstats2",
                    "id": "#main/clstats2"
                },
                {
                    "type": "File",
                    "outputSource": "#main/picard.MarkDuplicates/mdmetrics",
                    "id": "#main/md_metrics"
                }
            ],
            "steps": [
                {
                    "run": "#bwa-mem.cwl",
                    "in": [
                        {
                            "source": "#main/add_rg_CN",
                            "id": "#main/bwa_mem/CN"
                        },
                        {
                            "source": "#main/add_rg_ID",
                            "id": "#main/bwa_mem/ID"
                        },
                        {
                            "source": "#main/add_rg_LB",
                            "id": "#main/bwa_mem/LB"
                        },
                        {
                            "source": "#main/add_rg_PL",
                            "id": "#main/bwa_mem/PL"
                        },
                        {
                            "source": "#main/add_rg_PU",
                            "id": "#main/bwa_mem/PU"
                        },
                        {
                            "source": "#main/add_rg_SM",
                            "id": "#main/bwa_mem/SM"
                        },
                        {
                            "valueFrom": "$(inputs.run_tools.bwa_path)",
                            "id": "#main/bwa_mem/bwa"
                        },
                        {
                            "source": "#main/trimgalore/clfastq1",
                            "id": "#main/bwa_mem/fastq1"
                        },
                        {
                            "source": "#main/trimgalore/clfastq2",
                            "id": "#main/bwa_mem/fastq2"
                        },
                        {
                            "source": "#main/reference_fasta",
                            "id": "#main/bwa_mem/reference_fasta"
                        },
                        {
                            "source": "#main/reference_fasta_fai",
                            "id": "#main/bwa_mem/reference_fasta_fai"
                        },
                        {
                            "source": "#main/run_tools",
                            "id": "#main/bwa_mem/run_tools"
                        }
                    ],
                    "out": [
                        "#main/bwa_mem/output_sam"
                    ],
                    "id": "#main/bwa_mem"
                },
                {
                    "run": "#AddOrReplaceReadGroups.cwl",
                    "in": [
                        {
                            "source": "#main/add_rg_CN",
                            "id": "#main/picard.AddOrReplaceReadGroups/CN"
                        },
                        {
                            "source": "#main/add_rg_ID",
                            "id": "#main/picard.AddOrReplaceReadGroups/ID"
                        },
                        {
                            "source": "#main/add_rg_LB",
                            "id": "#main/picard.AddOrReplaceReadGroups/LB"
                        },
                        {
                            "source": "#main/add_rg_PL",
                            "id": "#main/picard.AddOrReplaceReadGroups/PL"
                        },
                        {
                            "source": "#main/add_rg_PU",
                            "id": "#main/picard.AddOrReplaceReadGroups/PU"
                        },
                        {
                            "source": "#main/add_rg_SM",
                            "id": "#main/picard.AddOrReplaceReadGroups/SM"
                        },
                        {
                            "valueFrom": "$(inputs.run_tools.arrg_path)",
                            "id": "#main/picard.AddOrReplaceReadGroups/arrg"
                        },
                        {
                            "valueFrom": "$(inputs.params.compression_level)",
                            "id": "#main/picard.AddOrReplaceReadGroups/compression_level"
                        },
                        {
                            "valueFrom": "$(inputs.params.create_index)",
                            "id": "#main/picard.AddOrReplaceReadGroups/create_index"
                        },
                        {
                            "source": "#main/bwa_mem/output_sam",
                            "id": "#main/picard.AddOrReplaceReadGroups/input_sam"
                        },
                        {
                            "valueFrom": "$(inputs.run_tools.java_7)",
                            "id": "#main/picard.AddOrReplaceReadGroups/java"
                        },
                        {
                            "source": "#main/add_or_replace_read_groups__params",
                            "id": "#main/picard.AddOrReplaceReadGroups/params"
                        },
                        {
                            "source": "#main/run_tools",
                            "id": "#main/picard.AddOrReplaceReadGroups/run_tools"
                        },
                        {
                            "valueFrom": "$(inputs.params.sort_order)",
                            "id": "#main/picard.AddOrReplaceReadGroups/sort_order"
                        },
                        {
                            "valueFrom": "$(inputs.params.validation_stringency)",
                            "id": "#main/picard.AddOrReplaceReadGroups/validation_stringency"
                        }
                    ],
                    "out": [
                        "#main/picard.AddOrReplaceReadGroups/bam",
                        "#main/picard.AddOrReplaceReadGroups/bai"
                    ],
                    "id": "#main/picard.AddOrReplaceReadGroups"
                },
                {
                    "run": "#MarkDuplicates.cwl",
                    "in": [
                        {
                            "valueFrom": "$(inputs.params.assume_sorted)",
                            "id": "#main/picard.MarkDuplicates/assume_sorted"
                        },
                        {
                            "valueFrom": "$(inputs.params.compression_level)",
                            "id": "#main/picard.MarkDuplicates/compression_level"
                        },
                        {
                            "valueFrom": "$(inputs.params.create_index)",
                            "id": "#main/picard.MarkDuplicates/create_index"
                        },
                        {
                            "valueFrom": "$(inputs.params.duplicate_scoring_strategy)",
                            "id": "#main/picard.MarkDuplicates/duplicate_scoring_strategy"
                        },
                        {
                            "source": "#main/picard.AddOrReplaceReadGroups/bam",
                            "id": "#main/picard.MarkDuplicates/input_bam"
                        },
                        {
                            "valueFrom": "$(inputs.run_tools.java_8)",
                            "id": "#main/picard.MarkDuplicates/java"
                        },
                        {
                            "source": "#main/mark_duplicates__params",
                            "id": "#main/picard.MarkDuplicates/params"
                        },
                        {
                            "valueFrom": "$(inputs.run_tools.picard_path)",
                            "id": "#main/picard.MarkDuplicates/picard"
                        },
                        {
                            "source": "#main/run_tools",
                            "id": "#main/picard.MarkDuplicates/run_tools"
                        },
                        {
                            "valueFrom": "$(inputs.params.validation_stringency)",
                            "id": "#main/picard.MarkDuplicates/validation_stringency"
                        }
                    ],
                    "out": [
                        "#main/picard.MarkDuplicates/bam",
                        "#main/picard.MarkDuplicates/bai",
                        "#main/picard.MarkDuplicates/mdmetrics"
                    ],
                    "id": "#main/picard.MarkDuplicates"
                },
                {
                    "run": "#trimgalore.cwl",
                    "in": [
                        {
                            "source": "#main/adapter",
                            "id": "#main/trimgalore/adapter"
                        },
                        {
                            "source": "#main/adapter2",
                            "id": "#main/trimgalore/adapter2"
                        },
                        {
                            "source": "#main/fastq1",
                            "id": "#main/trimgalore/fastq1"
                        },
                        {
                            "source": "#main/fastq2",
                            "id": "#main/trimgalore/fastq2"
                        },
                        {
                            "valueFrom": "$(inputs.params.gzip)",
                            "id": "#main/trimgalore/gzip"
                        },
                        {
                            "valueFrom": "$(inputs.params.length)",
                            "id": "#main/trimgalore/length"
                        },
                        {
                            "valueFrom": "$(inputs.params.paired)",
                            "id": "#main/trimgalore/paired"
                        },
                        {
                            "source": "#main/trimgalore__params",
                            "id": "#main/trimgalore/params"
                        },
                        {
                            "valueFrom": "$(inputs.run_tools.perl_5)",
                            "id": "#main/trimgalore/perl"
                        },
                        {
                            "valueFrom": "$(inputs.params.quality)",
                            "id": "#main/trimgalore/quality"
                        },
                        {
                            "source": "#main/run_tools",
                            "id": "#main/trimgalore/run_tools"
                        },
                        {
                            "valueFrom": "$(inputs.params.stringency)",
                            "id": "#main/trimgalore/stringency"
                        },
                        {
                            "valueFrom": "$(inputs.params.suppress_warn)",
                            "id": "#main/trimgalore/suppress_warn"
                        },
                        {
                            "valueFrom": "$(inputs.run_tools.trimgalore_path)",
                            "id": "#main/trimgalore/trimgalore"
                        }
                    ],
                    "out": [
                        "#main/trimgalore/clfastq1",
                        "#main/trimgalore/clfastq2",
                        "#main/trimgalore/clstats1",
                        "#main/trimgalore/clstats2"
                    ],
                    "id": "#main/trimgalore"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
